import * as i0 from '@angular/core';
import { Injectable, Component, Inject, Input, ContentChild, ViewChild } from '@angular/core';
import { AsyncPipe } from '@angular/common';
import { Validators, NgControl } from '@angular/forms';
import { BehaviorSubject } from 'rxjs';

class NgValidationService {
    constructor() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NgValidationService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NgValidationService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NgValidationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

const ERROR_MESSAGE = {
    // error: {
    required: (name, { ...args }) => `${name} is required`,
    minlength: (name, { ...args }) => { console.log(args); return `${name} cannot be less than ${args?.["requiredLength"]} characters`; },
    maxlength: (name, { ...args }) => `${name} cannot be more than ${args?.["requiredLength"]} characters`,
    min: (name, { ...args }) => `${name} cannot be less than ${args?.["min"]}`,
    max: (name, { ...args }) => `${name} cannot be more than ${args?.["max"]}`,
    email: (name, { ...args }) => `${name} is invalid`,
    isNotAlphabet: (name, { ...args }) => `${name} should be alphabets`,
    isNotSmallCase: (name, { ...args }) => `${name} should be smallcase charecters`,
    isNotLargeCase: (name, { ...args }) => `${name} should be largecase charecters`,
    isNotNumeric: (name, { ...args }) => `${name} should be number`,
    isNotCode: (name, { ...args }) => `${name} should be alphanumeric`,
    isUrl: (name, { ...args }) => `${name} should be url`,
    isColourCode: (name, { ...args }) => `${name} should be color`,
    isGeoLocation: (name, { ...args }) => `${name} should be geo location`,
    ipv4: (name, { ...args }) => `${name} should be ipv4`,
    ipv6: (name, { ...args }) => `${name} should be ipv6`,
    // }
};

const messages = {
    required: 'This is invalid'
};
class NgValidationComponent {
    constructor(customMessages) {
        this.customMessages = customMessages;
        this.label = "field";
        this.isControlError = false;
        this.requiredStar = false;
        this.errorMsg = new BehaviorSubject("");
    }
    ngAfterViewInit() {
        this.formControl?.control?.valueChanges.subscribe(value => {
            if (this.formControl && this.formControl.control && this.formControl.control.errors) {
                this.formGroup.nativeElement.classList.add('e-error');
                this.isControlError = true;
                this.errorMsg.next(this.getErrorMessage(this.formControl, this.label));
            }
            if (this.formControl && this.formControl.control && !this.formControl.control.errors) {
                this.formGroup.nativeElement.classList.remove('e-error');
                this.isControlError = false;
            }
        });
    }
    get validator() {
        return this?.formControl?.control?.hasValidator(Validators.required);
        // console.log(validator);
        // if (validator) {
        //   return true;
        // }
    }
    getErrorMessage(formControl, field) {
        let name = field || 'This Field';
        name = name.charAt(0).toUpperCase() + name.slice(1);
        if (formControl.invalid) {
            const errors = formControl.control?.errors;
            const [errorKey] = Object.keys(errors);
            let message = `${name}  is invalid`;
            if (errorKey in ERROR_MESSAGE) {
                return ERROR_MESSAGE[errorKey](name, errors[errorKey]);
            }
            else if (errorKey in this.customMessages) {
                return this.customMessages[errorKey](name, errors[errorKey]);
            }
            // if (errorKey === 'minlength' || errorKey === 'maxlength'|| errorKey === 'min' || errorKey === 'max') {
            // message = ERROR_MESSAGE[errorKey](name, error[errorKey])
            // } else {
            // message = this.customMessages[errorKey](name, error[errorKey])
            // }
            return message;
        }
        return (`${name}  is invalid`);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NgValidationComponent, deps: [{ token: 'CUSTOM_MESSAGES' }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.3.12", type: NgValidationComponent, isStandalone: true, selector: "validate", inputs: { label: "label" }, providers: [{ provide: 'CUSTOM_MESSAGES', useValue: messages }], queries: [{ propertyName: "formControl", first: true, predicate: NgControl, descendants: true }, { propertyName: "formControlElement", first: true, predicate: ["control"], descendants: true }], viewQueries: [{ propertyName: "formGroup", first: true, predicate: ["formGroup"], descendants: true }], ngImport: i0, template: `
    <div #formGroup class="form-group">
    <div>
        {{label}} @if (validator) {<sup class="mandatory-sign">*</sup>}
    </div>
    <div>
        <ng-content></ng-content>
         @if (isControlError) 
          {<div class="error-message">
            {{errorMsg| async}}
          </div>
          }
    </div>

</div>
  `, isInline: true, styles: [""], dependencies: [{ kind: "pipe", type: AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.3.12", ngImport: i0, type: NgValidationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'validate', standalone: true, imports: [AsyncPipe], providers: [{ provide: 'CUSTOM_MESSAGES', useValue: messages }], template: `
    <div #formGroup class="form-group">
    <div>
        {{label}} @if (validator) {<sup class="mandatory-sign">*</sup>}
    </div>
    <div>
        <ng-content></ng-content>
         @if (isControlError) 
          {<div class="error-message">
            {{errorMsg| async}}
          </div>
          }
    </div>

</div>
  ` }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: ['CUSTOM_MESSAGES']
                }] }], propDecorators: { label: [{
                type: Input
            }], formControl: [{
                type: ContentChild,
                args: [NgControl]
            }], formControlElement: [{
                type: ContentChild,
                args: ['control']
            }], formGroup: [{
                type: ViewChild,
                args: ['formGroup']
            }] } });

/*
 * Public API Surface of ng-validation
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgValidationComponent, NgValidationService };
//# sourceMappingURL=ng-validation.mjs.map
